/************************************************************/
/* QG8ŌXΌvB\ɂ̓OtBbNLCDgp           */
/* _gȂꍇansiis.libNB       */
/* _gꍇansifs.libNB           */
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include <math.h>
#include <string.h>
#include "derivative.h" /* include peripheral declarations */

#define _DEBUG_

#define _CPU_CLOCK_  (8000000UL)
#define _BUS_CLOCK_  (4000000UL)

//#define  OVER_SAMPLE 64  /*I[o[Tv*/
#define  OVER_SAMPLE 256  /*I[o[Tv*/

#define PERIOD_1s    (_BUS_CLOCK_ / 128)
#define PERIOD_3R9ms  (_BUS_CLOCK_ / 128 / 256)
#define PERIOD_7R8ms  (_BUS_CLOCK_ / 128 / 128)
#define PERIOD_15R6ms  (_BUS_CLOCK_ / 128 / 64)
#define PERIOD_62R5ms  (_BUS_CLOCK_ / 128 / 16)

#define  X_OFFSET    (505.3203125 * OVER_SAMPLE)
#define  X_MAX       ((754.62890625 - 505.3203125) * OVER_SAMPLE)
#define  X_MIN       ((754.62890625 - 505.3203125) * OVER_SAMPLE)

#define  Y_OFFSET    (467.6328125 * OVER_SAMPLE)
#define  Y_MAX       ((722.80078125 - 467.6328125) * OVER_SAMPLE)
#define  Y_MIN       ((722.80078125 - 467.6328125) * OVER_SAMPLE)

#ifdef  _DEBUG_
#define  WAIT
#define  STOP
#else  /*_DEBUG_*/
#define  WAIT    __asm WAIT;
#define  STOP    __asm STOP;
#endif  /*_DEBUG_*/

#define  SLEEP       PTAD_PTAD3    /*xZT[ SLEEP[qB1ŃANeBu*/

/****************************************************************/
/* ϐ̊F                                             */
/****************************************************************/
unsigned long ad_data[ 3 ];
int ad_convert_end;

/************************************************************/
/* vg^Cv錾                                         */
/************************************************************/

/************************************************************/
/* vOmain                                           */
/************************************************************/
void main(void)
{
  unsigned long x_us,y_us,z_us;
  double x_db,y_db;
  double z_db;

  /*watch dog timer̒~*/
#ifdef  _DEBUG_
  SOPT1_COPE = 0;
//  SOPT1_BKGDPE = 0;
#else  /*_DEBUG_*/
  SOPT1 = SOPT1_STOPE_MASK | SOPT1_RSTPE_MASK;
#endif  /*_DEBUG_*/

  /*NbN̏*/
  ICSC1 = 0x04;  /*0b00 000 1 0 0*/
  ICSC2_BDIV = 1;  /*oXNbN2*/
  ICSTRM = *((unsigned char *)0xffaf);
  ICSSC_FTRIM = (*((unsigned char *)0xffae) & 0x01) ? 1 : 0;

  /*@\^C}[gp*/
  TPMSC = 0x07;     /*0b0 0 00 111 ^C}[~Asystem clock / 128*/
  TPMMOD = PERIOD_7R8ms;  /*ݒ*/
  TPMSC_TOIE = 1;   /*interrupt enable*/
  TPMSC_CLKSx = 1;  /*oXNbN̑I*/

  /*ADC setting*/
  ADCSC1_AIEN = 1;  /* Enable interrupts */
  ADCSC2_ADTRG = 0; /* Select S/W trigger*/
  /*FADCK0.4M`4MHz̊Ԃɓ鎖*/
  ADCCFG = 0x98;    /* 0b1001 1000 d͐ݒ
                     ̓NbN1
                     Tv
                     10bitϊ
                     oXNbN2 */
  APCTL1 = 0x07;  /*Enable pins 16,15,14 as ADC inputs*/

  /*ėp|[g̐ݒ*/
  PTADD = 0x18;	/*0001 1000*/
  PTBDD = 0xbe;	/*1011 1110*/
  SLEEP = 1;  //MM2860SLEEP

  EnableInterrupts; /* enable interrupts */

  for( ; ; )
  {
    WAIT;  /*xȓd̓[hɓB荞݂ƁA̖̎߂sB*/
    if( ad_convert_end != 0 )
    {
      /*TvOꂽf[^*/
      x_us = ad_data[ 0 ];
      y_us = ad_data[ 1 ];
      z_us = ad_data[ 2 ];
      (void)memset( ad_data, 0, sizeof(ad_data) );
      ad_convert_end = 0;

      x_db = asin( (x_us - X_OFFSET) / X_MAX ) / _M_2PI * 360.0;
      y_db = asin( (y_us - Y_OFFSET) / Y_MAX ) / _M_2PI * 360.0;
    }
  }
}

/****************************************************************/
/* tpm interrupt 7.8ms̊荞݂ƂȂ                      */
/****************************************************************/
interrupt 7 void TPM_C_MATCH_ISR(void)
{
  TPMSC_TOF = 0;	/*clear status*/

  ADCSC1_ADCH = 0; /*ϊ`l̑IƁAϊJn*/
}

/****************************************************************/
/* adc interrupt                                                */
/****************************************************************/
interrupt 19 void ADC_ISR( void )
{
  static int count;
  unsigned short data;

  data = ADCR;  /*10bit̂ݗL*/
  if( ad_convert_end == 0 )  /*ϐւ̏㏑h~*/
  {
    switch( ADCSC1_ADCH )
    {
      case 0 :  /*X̃TvO*/
        ADCSC1_ADCH = 1;  /*̃`l̕ϊv*/
        ad_data[ 0 ] += data;
        break;

      case 1 :  /*ỸTvO*/
        ADCSC1_ADCH = 2;  /*̃`l̕ϊv*/
        ad_data[ 1 ] += data;
        break;

      case 2 :  /*Z̃TvO*/
      default :
        ad_data[ 2 ] += data;
        if( ++count >= OVER_SAMPLE )
        {
          ad_convert_end = 1;
          count = 0;
        }
        break;
    }
  }
}

/************************************************************/
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
